include "ZeroPage.inc"
include "VVram.inc"
include "Chars.inc"

ext VVram_
ext pStage_, StageMap_, topRow_, yMod_

FloorHeight equ 4
ColumnCount equ 12
VisibleFloorCount equ (VVramHeight+FloorHeight-1)/FloorHeight+1
MapWidth equ ColumnCount/4

CellType_Space equ 0
CellType_Ladder equ 1
CellType_Wall equ 2
CellType_Hole equ 3


; ptr<byte> VVramPtr(byte x, byte y);
dseg
VVramPtr_@Param1: public VVramPtr_@Param1
VVramPtr_y:
    defs 1
cseg
VVramPtr_: public	VVramPtr_
	psha | pshb
        staa <ZB0
        ldaa #VVramWidth
        ldab VVramPtr_y
        mul
        addb <ZB0
        adca #0
        addb #low VVram_
        adca #high VVram_
        xgdx
	pulb | pula
rts


height equ ZB0
row equ ZB1
ypos equ ZB2
fcount equ ZB3

pMap equ ZW0
pair equ ZW1
pVVram equ ZW2

byteCount equ ZB4
bitCount equ ZB5
bits equ ZW3+0
lower equ ZW3+1


; MapToBackGround();
cseg
Repeat:
    psha
        do
            ldx <pVVram
            ldaa <ypos
            cmpa #VVramHeight
            if cs
                ldaa <pair | staa 0,x
                ldaa <pair+1 | staa 1,x
            endif
            ldaa <pVVram+1 | adda #VVramWidth | staa<pVVram+1
            ldaa <pVVram | adca #0 | staa<pVVram
            inc <ypos
            decb
        while ne | wend
    pula
rts

MapToBackGround_: public MapToBackGround_
    psha | pshb
        ldx pStage_
        ldaa 0,x
        staa <height

        ldaa topRow_ | staa <row
        if pl
            staa <pMap+1
            asla ;*2
            adda <pMap+1 ;*3
            adda #low StageMap_
            staa <pMap+1
            ldaa #high StageMap_
            adca #0
            staa <pMap
        else
            ldx #StageMap_-MapWidth
            stx <pMap
        endif

        ldaa yMod_
        if ne
            nega
        endif
        staa <ypos
        ldx #VVram_
        stx <pVVram
        do
            tsta
        while mi
            ldab <pVVram+1 | subb #VVramWidth | stab <pVVram+1
            ldab <pVVram | sbcb #0 | stab <pVVram
            inca
        wend
        ldaa #VisibleFloorCount | staa <fcount
        do
            ldaa #MapWidth | staa <byteCount
            do
                ldx <pMap
                ldab <row
                if pl
                    ldaa 0,x
                    incb
                    cmpb <height
                    if cs
                        ldab MapWidth,x
                    else
                        clrb
                    endif
                else
                    clra
                    ldab MapWidth,x
                endif
                staa <bits
                stab <lower
                inx
                stx <pMap

                ldaa #4 | staa <bitCount
                do
                    ldaa <bits
                    anda #3
                    if eq
                        ldx #((Char_Space shl 8) or Char_Space)
                        stx <pair
                        ldab #1
                        bsr Repeat

                        ldaa <lower
                        anda #3
                        cmpa #CellType_Ladder
                        if eq
                            ldx #((Char_Ladder_Left shl 8) or Char_Ladder_Right)
                            stx <pair
                            ldab #3
                            bsr Repeat
                        else
                            ldab #2
                            bsr Repeat

                            cmpa #CellType_Wall
                            if eq
                                ldx #((Char_Wall shl 8) or Char_Floor)
                            else
                                ldx #((Char_Floor shl 8) or Char_Floor)
                            endif
                            stx <pair
                            ldab #1
                            bsr Repeat
                        endif
                    else
                        cmpa #CellType_Ladder
                        if eq
                            ldx #((Char_Ladder_Left shl 8) or Char_Ladder_Right)
                            stx <pair
                            ldab #3
                            bsr Repeat

                            ldaa <lower
                            anda #3
                            cmpa #CellType_Ladder
                            if eq
                                ldx #((Char_Ladder_Left shl 8) or Char_Ladder_Right)
                            else
                                cmpa #CellType_Wall
                                if eq
                                    ldx #((Char_Wall shl 8) or Char_Floor)
                                else
                                    ldx #((Char_Floor shl 8) or Char_Floor)
                                endif
                            endif
                            stx <pair
                            ldab #1
                            bsr Repeat
                        else
                            cmpa #CellType_Wall
                            if eq
                                ldx #((Char_Wall shl 8) or Char_Space)
                                stx <pair
                                ldab #3
                                bsr Repeat
                                
                                ldaa <lower
                                anda #3
                                cmpa #CellType_Wall
                                if eq
                                    ldx #((Char_Wall shl 8) or Char_Floor)
                                else
                                    ldx #((Char_Floor shl 8) or Char_Floor)
                                endif
                                stx <pair
                                ldab #1
                                bsr Repeat
                            else
                                ldx #((Char_Space shl 8) or Char_Space)
                                stx <pair
                                ldab #4
                                bsr Repeat
                            endif
                        endif
                    endif
                    ldaa <pVVram+1 | adda #low (-VVramWidth*4+2) | staa <pVVram+1
                    ldaa <pVVram | adca #high (-VVramWidth*4+2) | staa <pVVram
                    lsr <bits | lsr <bits
                    lsr <lower | lsr <lower
                    ldaa <ypos
                    suba #FloorHeight
                    staa <ypos
                    dec <bitCount
                while ne | wend
                dec <byteCount
            while ne | wend
            ldaa <pVVram+1 | adda #low (VVramWidth*(4-1)) | staa <pVVram+1
            ldaa <pVVram | adca #high (VVramWidth*(4-1)) | staa <pVVram
            inc <row
            ldaa <ypos
            adda #FloorHeight
            staa <ypos
            dec <fcount
        while ne | wend
    pulb | pula
rts